<div class="py-4">
    @if (topic === null) {
        <p class="text-xl">Page des posts</p>
        <div class="text-center absolute right-1/2 top-1/2 -translate-y-1/2 translate-x-1/2">
            <p>Le topic n'a pas été trouvé...</p>
            <div class="h-10"></div>
            <app-main-button
                [label]="'Retour à la liste des topics'"
                [isLoading]="false"
                [isDisabled]="false"
                (onClick)="goToTopics()"
            />
        </div>
    }
    @else if (topic === undefined || posts === undefined || pagination === undefined) {
        <p class="text-xl">Page des posts</p>
        <div class="absolute right-1/2 top-1/2 -translate-y-1/2 translate-x-1/2">
            <p>Chargement des données en cours...</p>
        </div>
    }
    @else {
        <div class="flex gap-6 text-xl">
            <p>Page des posts</p>
            <p>-</p>
            <div class="flex gap-2">
                <p class="text-blue-600 cursor-pointer" (click)="goToTopics()">topics</p>
                <p>/</p>
                <p>{{ topic.title }}</p>
            </div>
        </div>
        <div class="text-center mt-4">
            <div class="inline-block">
                <div class="flex flex-cols gap-4">
                    <div>
                        <p-table [value]="posts" styleClass="p-datatable-striped"  [tableStyle]="{ 'min-width': '50rem', 'width': '1000px' }">
                            <ng-template pTemplate="header">
                                <tr>
                                    <th>Contenu</th>
                                    <th>Auteur</th>
                                    <th>Créé le</th>
                                    <th>Actions</th>
                                </tr>
                            </ng-template>
                            @if (posts.length > 0) {
                                <ng-template pTemplate="body" let-post>
                                    <tr class="hover:bg-[#F4ECF5]">
                                        <td>{{ post.content }}</td>
                                        <td>{{ post.author.firstname }} {{ post.author.lastname }}</td>
                                        <td>{{ post.createdAt | date: 'dd/MM/YYYY HH:mm' }}</td>
                                        <td class="flex justify-around">
                                            @if (currentUserId === post.authorId) {
                                                <span class="border border-blue-500 rounded-lg bg-blue-100 px-2 py cursor-pointer" (click)="onUpdate(post.id)">Modifier</span>
                                                <span class="border border-red-500 rounded-lg bg-red-100 px-2 py cursor-pointer" (click)="onDelete(post.id)">Supprimer</span>
                                            }
                                        </td>
                                    </tr>
                                </ng-template>
                            }
                            @else {
                                <ng-template pTemplate="body">
                                    <tr>
                                        <td colspan="4" class="text-center">Aucun post trouvé</td>
                                    </tr>
                                </ng-template>
                            }
                        </p-table>
                        <div class="h-4"></div>
                        <p-paginator 
                            (onPageChange)="onPaginationChange($event)" 
                            [first]="currentPage"
                            [rows]="pagination.limit" 
                            [totalRecords]="pagination.totalAmount"
                        />
                    </div>
                    <div>
                        <div>
                            <div class="bg-white rounded-lg border border-[#DADADA] px-5 py-4 flex flex-col gap-4">
                                <div class="flex justify-between items-center">
                                    <p>Filtres</p>
                                    <app-main-button
                                        [label]="'Créer un post'"
                                        [isDisabled]="false"
                                        [isLoading]="false"
                                        (onClick)="addPost()"
                                    />
                                </div>
                                <hr/>
                                <form [formGroup]="postFilterForm">
                                    <div class="flex flex-col gap-2">
                                        <div class="flex gap-2 items-center">
                                            <p>Titre : </p>
                                            <app-text-input
                                                [type]="'text'"
                                                [formControlName]="'content'"
                                                [placeholder]="'Contenu du post'"
                                                [isError]="false"
                                                [guestForm]="postFilterForm"
                                            />
                                        </div>
                                        <app-main-button
                                            [label]="'Filtrer'"
                                            [isDisabled]="false"
                                            [isLoading]="false"
                                            (onClick)="onFilter()"
                                        />
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    }
</div>